require_work_tree
# Returns true if the mode reflects a symlink
-function is_symlink () {
+is_symlink () {
test "$1" = 120000
}
-function local_present () {
+local_present () {
test -n "$local_mode"
}
-function remote_present () {
+remote_present () {
test -n "$remote_mode"
}
-function base_present () {
+base_present () {
test -n "$base_mode"
}
fi
}
-function describe_file () {
+describe_file () {
mode="$1"
branch="$2"
file="$3"
- echo -n " "
+ printf " "
if test -z "$mode"; then
- echo -n "'$path' was deleted"
+ printf "'%s' was deleted" "$path"
elif is_symlink "$mode" ; then
- echo -n "'$path' is a symlink containing '"
- cat "$file"
- echo -n "'"
+ printf "'%s' is a symlink containing '%s'" "$path" "$file"
else
if base_present; then
- echo -n "'$path' was created"
+ printf "'%s' was created" "$path"
else
- echo -n "'$path' was modified"
+ printf "'%s' was modified" "$path"
fi
fi
echo " in the $branch branch"
resolve_symlink_merge () {
- while /bin/true; do
- echo -n "Use (r)emote or (l)ocal, or (a)bort? "
+ while true; do
+ printf "Use (r)emote or (l)ocal, or (a)bort? "
read ans
case "$ans" in
[lL]*)
}
resolve_deleted_merge () {
- while /bin/true; do
- echo -n "Use (m)odified or (d)eleted file, or (a)bort? "
+ while true; do
+ printf "Use (m)odified or (d)eleted file, or (a)bort? "
read ans
case "$ans" in
[mM]*)
merge_file () {
path="$1"
- if test ! -f "$path" ; then
- echo "$path: file not found"
- exit 1
- fi
-
f=`git-ls-files -u -- "$path"`
if test -z "$f" ; then
- echo "$path: file does not need merging"
+ if test ! -f "$path" ; then
+ echo "$path: file not found"
+ else
+ echo "$path: file does not need merging"
+ fi
exit 1
fi
echo "Normal merge conflict for $path:"
describe_file "$local_mode" "local" "$LOCAL"
describe_file "$remote_mode" "remote" "$REMOTE"
- echo -n "Hit return to start merge resolution tool ($merge_tool): "
+ printf "Hit return to start merge resolution tool (%s): " "$merge_tool"
read ans
case "$merge_tool" in
mv -- "$BACKUP" "$path.orig"
fi
;;
- meld)
+ meld|vimdiff)
touch "$BACKUP"
- meld -- "$LOCAL" "$path" "$REMOTE"
+ $merge_tool -- "$LOCAL" "$path" "$REMOTE"
if test "$path" -nt "$BACKUP" ; then
status=0;
else
while true; do
echo "$path seems unchanged."
- echo -n "Was the merge successful? [y/n] "
+ printf "Was the merge successful? [y/n] "
read answer < /dev/tty
case "$answer" in
y*|Y*) status=0; break ;;
else
while true; do
echo "$path seems unchanged."
- echo -n "Was the merge successful? [y/n] "
+ printf "Was the merge successful? [y/n] "
read answer < /dev/tty
case "$answer" in
y*|Y*) status=0; break ;;
if test -z "$merge_tool"; then
merge_tool=`git-config merge.tool`
- if test $merge_tool = kdiff3 -o $merge_tool = tkdiff -o \
- $merge_tool = xxdiff -o $merge_tool = meld ; then
- unset merge_tool
- fi
+ case "$merge_tool" in
+ kdiff3 | tkdiff | xxdiff | meld | emerge | vimdiff)
+ ;; # happy
+ *)
+ echo >&2 "git config option merge.tool set to unknown tool: $merge_tool"
+ echo >&2 "Resetting to default..."
+ unset merge_tool
+ ;;
+ esac
fi
if test -z "$merge_tool" ; then
merge_tool=meld
elif type emacs >/dev/null 2>&1; then
merge_tool=emerge
+ elif type vimdiff >/dev/null 2>&1; then
+ merge_tool=vimdiff
else
echo "No available merge resolution programs available."
exit 1
fi
case "$merge_tool" in
- kdiff3|tkdiff|meld|xxdiff)
+ kdiff3|tkdiff|meld|xxdiff|vimdiff)
if ! type "$merge_tool" > /dev/null 2>&1; then
echo "The merge tool $merge_tool is not available"
exit 1
echo Merging the files: $files
git ls-files -u | sed -e 's/^[^ ]* //' | sort -u | while read i
do
- echo ""
+ printf "\n"
merge_file "$i" < /dev/tty > /dev/tty
done
else
while test $# -gt 0; do
- echo ""
+ printf "\n"
merge_file "$1"
shift
done